package com.zipcodewilmington.looplabs;

import java.util.Arrays;

/**
 * Created by leon on 1/29/18.
 * @ATTENTION_TO_STUDENTS You are forbidden from modifying the signature of this class.
 */
public final class IntegerDuplicateDeleter extends DuplicateDeleter<Integer> {

    public IntegerDuplicateDeleter(Integer[] intArray) {
        super(intArray);
    }

    @Override
    public Integer[] removeDuplicates(int maxNumberOfDuplications) {

        Integer [] result = new Integer[array.length];
        int count = 0;
        for (int i = 0; i < array.length ; i++) {
            if(itemCount(array[i]) < maxNumberOfDuplications){
                result[count] = array[i];
                count++;}
            }
            return Arrays.copyOfRange(result,0,count);
        }

//        Integer[] arr = Arrays.copyOf(array,array.length);
//        StringBuilder stringBuilder = new StringBuilder();
//
//        for (int i = 0; i < arr.length ; i++) {
//            int count = 1;
//            for (int j = 0; j < arr.length; j++) {
//                if (arr[j].equals(arr[i])) {
//                    count++;
//                }
//            }
//            if (count <= maxNumberOfDuplications)
//                stringBuilder.append(arr[i]).append("/");
//        }
//        if(!stringBuilder.toString().equals("")){
//            arr =getNewArr(stringBuilder);
//        }else{
//            arr = new Integer[0];
//        }
//        return arr;
//    }


    private int itemCount(int item) {
        int counter = 0;
        for (int items : array) {
            if (items == item)
                counter++;
        }
        return counter;
    }
//    private Integer[] getNewArr(StringBuilder stringBuilder) {
//        Integer [] arr;
//        String [] strings = stringBuilder.toString().split("/");
//        arr = new Integer[strings.length];
//        for (int i = 0; i < arr.length; i++)
//            arr[i] = Integer.valueOf(strings[i]);
//            return arr;
//    }

    @Override
    public Integer[] removeDuplicatesExactly(int exactNumberOfDuplications) {

        Integer [] result = new Integer[array.length];
        int count = 0;
        for (int i = 0; i < array.length ; i++) {
            if(itemCount(array[i]) != exactNumberOfDuplications){
                result[count] = array[i];
                count++;
            }
        }
        return Arrays.copyOfRange(result,0,count);
    }


//        StringBuilder stringBuilder = new StringBuilder();
//        Integer [] arr = Arrays.copyOf(array,array.length);
//        for (int i = 0; i < arr.length; i++) {
//            int count = 0;
//            for (int j = 0; j < arr.length; j++) {
//                if (arr[j].equals(arr[i])) {
//                    count++;
//                }
//            }
//            if (count != exactNumberOfDuplications)
//                stringBuilder.append(arr[i]).append("/");
//        }
//        if(!stringBuilder.toString().equals("")){
//            arr =getNewArr(stringBuilder);
//        }else{
//            arr = new Integer[0];
//        }
//        return arr;
    }

